%bcond_with     python2
%global py2dir  %{_builddir}/python2-%{name}-%{version}-%{release}

Name:           python-cached_property
Version:        1.5.1
Release:        1
Summary:        A cached-property for decorating methods in Python classes
License:        BSD
URL:            https://github.com/pydanny/cached-property
Source0:        https://github.com/pydanny/cached-property/archive/%{version}/cached-property-%{version}.tar.gz

BuildArch:      noarch
BuildRequires:  python%{python3_pkgversion}-dateutil python3-devel
BuildRequires:  python%{python3_pkgversion}-freezegun python3-pytest
%if %{with python2}
BuildRequires:  python2-devel python2-dateutil python2-freezegun python2-pytest
%endif

%description
cached_property allows properties in Python classes to be cached until the cache
is invalidated or expired.

%if %{with python2}
%package     -n python2-cached_property
Summary:        A cached-property for decorating methods in Python classes.

%{?python_provide:%python_provide python2-cached_property}
Provides:       python2-cached-property = %{version}-%{release}
Obsoletes:      python2-cached-property < 1.3.0-2

%description -n python2-cached_property
cached_property allows properties in Python classes to be cached until the cache
is invalidated or expired.
%endif

%package     -n python%{python3_pkgversion}-cached_property
Summary:        A cached-property for decorating methods in Python classes.

%{?python_provide:%python_provide python%{python3_pkgversion}-cached_property}
Provides:       python%{python3_pkgversion}-cached-property = %{version}-%{release}
Obsoletes:      python%{python3_pkgversion}-cached-property < 1.3.0-2
%if ! %{with python2}
Obsoletes:      python2-cached_property < %{version}-%{release}
%endif

%description -n python%{python3_pkgversion}-cached_property
cached_property allows properties in Python classes to be cached until the cache
is invalidated or expired.

%package_help

%prep
%autosetup -n cached-property-%{version} -p1

%if %{with python2}
rm -rf %{py2dir}
cp -a . %{py2dir}
%endif

%build
%{__python3} setup.py build

%if %{with python2}
pushd %{py2dir}
%{__python2} setup.py build
popd
%endif

%install
%{__python3} setup.py install -O1 --skip-build --root %{buildroot}

%if %{with python2}
pushd %{py2dir}
%{__python2} setup.py install -O1 --skip-build --root %{buildroot}
popd
%endif

%check
PYTHONPATH=./ py.test-3

%if %{with python2}
PYTHONPATH=./ py.test-2
%endif

%if %{with python2}
%files -n python2-cached_property
%defattr(-,root,root)
%doc AUTHORS.rst
%license LICENSE
%{python2_sitelib}/cached_property*
%endif

%files -n python%{python3_pkgversion}-cached_property
%defattr(-,root,root)
%doc AUTHORS.rst
%license LICENSE
%{python3_sitelib}/cached_property*
%{python3_sitelib}/__pycache__/cached_property*

%files help
%defattr(-,root,root)
%doc HISTORY.rst CONTRIBUTING.rst README.rst

%changelog
* Wed Feb 12 2020 openEuler Buildteam <buildteam@openeuler.org> - 1.5.1-1
- Package init
